#ifndef  MODULES_COLOUR_H
#define  MODULES_COLOUR_H

/*
**   colour.h
**
**   (C) Copyright 1998-2001 Rocklyte Systems.
**       All Rights Reserved.
*/

#ifdef LOCAL_COLOUR

void BlurArea(struct Bitmap *, WORD SX, WORD SY, WORD EX, WORD EY, WORD Setting);
LONG CalcBrightness(struct FRGB *);
LONG ClosestColour(struct FRGB *, struct RGBPalette *);
LONG ColourMorph(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, LONG SrcColour, LONG DestColour);
LONG ColourToPalette(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR Palette, LONG RRGGBB);
void ConvertHSVToRGB(struct HSV *, struct FRGB *);
void ConvertRGBToHSV(struct FRGB *, struct HSV *);
LONG CopyPalette(struct RGBPalette *, struct RGBPalette *, LONG Start, LONG TotalColours, LONG DestCol);
void DarkenArea(struct Bitmap *Bitmap, WORD SX, WORD SY, WORD EX, WORD EndY, WORD Percent);
void DarkenPixel(struct Bitmap *, WORD X, WORD Y, WORD Percent);
void LightenArea(struct Bitmap *Bitmap, WORD SX, WORD SY, WORD EX, WORD EY, WORD Percent);
void LightenPixel(struct Bitmap *, WORD X, WORD Y, WORD Percent);
LONG PaletteMorph(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR SrcPalette, APTR DestPalette);
LONG PaletteToColour(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR Palette, LONG RRGGBB);
LONG RemapBitmap(struct Bitmap *, struct Bitmap *, WORD Performance);

#else

struct ColourBase {
  void (*BlurArea)(struct Bitmap *, WORD SX, WORD SY, WORD EX, WORD EY, WORD Setting);
  LONG (*CalcBrightness)(struct RGB *);
  LONG (*ClosestColour)(struct RGB *, struct RGBPalette *);
  void (*ConvertHSVToRGB)(struct HSV *, struct RGB *);
  void (*ConvertRGBToHSV)(struct RGB *, struct HSV *);
  LONG (*CopyPalette)(struct RGBPalette *, struct RGBPalette *, LONG ColStart, LONG TotalColours, LONG DestCol);
  void (*DarkenArea)(struct Bitmap *, WORD SX, WORD SY, WORD EX, WORD EY, WORD Percent);
  void (*DarkenPixel)(struct Bitmap *, WORD X, WORD Y, WORD Percent);
  void (*LightenArea)(struct Bitmap *, WORD SX, WORD SY, WORD EX, WORD EY, WORD Percent);
  void (*LightenPixel)(struct Bitmap *, WORD X, WORD Y, WORD Percent);
  LONG (*RemapBitmap)(struct Bitmap *, struct Bitmap *, WORD Performance);
  LONG (*ColourMorph)(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, LONG SrcColour, LONG DestColour);
  LONG (*ColourToPalette)(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR Palette, LONG RRGGBB);
  LONG (*PaletteMorph)(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR SrcPalette, APTR DestPalette);
  LONG (*PaletteToColour)(struct GScreen *, WORD FadeState, WORD Speed, LONG StartColour, LONG TotalColours, APTR Palette, LONG RRGGBB);
};

/*** Definitions for inline library calls ***/

#define BlurArea(a,b,c,d,e,f)          (ColourBase->BlurArea(a,b,c,d,e,f))
#define CalcBrightness(a)              (ColourBase->CalcBrightness(a))
#define ClosestColour(a,b)             (ColourBase->ClosestColour(a,b))
#define ColourMorph(a,b,c,d,e,f,g)     (ColourBase->ColourMorph(a,b,c,d,e,f,g))
#define ColourToPalette(a,b,c,d,e,f,g) (ColourBase->ColourToPalette(a,b,c,d,e,f,g))
#define ConvertHSVToRGB(a,b)           (ColourBase->ConvertHSVToRGB(a,b))
#define ConvertRGBToHSV(a,b)           (ColourBase->ConvertRGBToHSV(a,b))
#define CopyPalette(a,b,c,d,e)         (ColourBase->CopyPalette(a,b,c,d,e))
#define DarkenArea(a,b,c,d,e,f)        (ColourBase->DarkenArea(a,b,c,d,e,f))
#define DarkenPixel(a,b,c,d)           (ColourBase->DarkenPixel(a,b,c,d))
#define LightenArea(a,b,c,d,e,f)       (ColourBase->LightenArea(a,b,c,d,e,f))
#define LightenPixel(a,b,c,d)          (ColourBase->LightenPixel(a,b,c,d))
#define PaletteMorph(a,b,c,d,e,f,g)    (ColourBase->PaletteMorph(a,b,c,d,e,f,g))
#define PaletteToColour(a,b,c,d,e,f,g) (ColourBase->PaletteToColour(a,b,c,d,e,f,g))
#define RemapBitmap(a,b,c)             (ColourBase->RemapBitmap(a,b,c))

#endif

#endif /* MODULES_COLOUR_H */
